#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 1e9 + 7;

void madd(int &x, int y) {
    if ((x += y) >= MOD) {
        x -= MOD;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    map<vector<int>, int> dp;
    dp[vector<int>(k, 0)] = 1;
    for (int i = 0; i < n; ++i) {
        map<vector<int>, int> nxt;
        for (int mask = 0; mask < (1 << (k - 1)); ++mask) {
            int f = __builtin_popcount(mask);
            for (auto &[s, prob] : dp) {
                if (b[i] - (s.back() + f) < 0 || b[i] - (s.back() + f) > 1) {
                    continue;
                }
                auto x = s;
                rotate(x.begin(), x.begin() + 1, x.end() - 1);
                x.rbegin()[1] = 0;
                for (int i = 0; i < x.size() - 1; ++i) {
                    x[i] += mask >> i & 1;
                }
                x.back() = 0;
                x.back() = accumulate(x.begin(), x.end(), 0);
                madd(nxt[x], prob);
            }
        }
        swap(dp, nxt);
    }

    int ans = 0;
    for (auto &[u, v] : dp) {
        madd(ans, v);
    }
    cout << ans << endl;

    return 0;
}