#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, s;
    cin >> n >> s;

    vector<int> head(n), tail(n);
    vector<int> c;
    for (int i = 0; i < n; ++i) {
        int sz;
        cin >> sz;
        head[i] = (i > 0 ? tail[i - 1] : 0);
        tail[i] = head[i] + sz;
        for (int k = 0; k < sz; ++k) {
            int f;
            cin >> f;
            c.push_back(f);
        }
    }

    int m = c.size();
    vector dp(m + 1, vector<int>(s + 1, -1));
    dp[0][0] = 0;
    for (int i = 0, ptr = 0; i < m; ++i) {
        int isTail = tail[ptr] == i + 1;
        dp[i + 1] = dp[i];
        for (int k = s - c[i]; k >= 0; --k) {
            if (dp[i][k] >= 0) {
                dp[i + 1][k + c[i]] = i + 1;
            }
        }
        if (isTail) {
            for (int k = 0; k <= s; ++k) {
                if (dp[i + 1][k] - 1 < head[ptr]) {
                    dp[i + 1][k] = -1;
                }
            }
            ptr += 1;
        }
    }

    if (dp[m][s] == -1) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        int i = m;
        vector<int> answer;
        while (s > 0) {
            int f = dp[i][s] - 1;
            // cout << f << endl;
            s -= c[f];
            answer.push_back(f);
            i = f;
        }
        sort(answer.begin(), answer.end());
        vector<vector<int>> adj(n);
        int k = 0;
        for (int x : answer) {
            while (tail[k] <= x) {
                k += 1;
            }
            adj[k].push_back(x);
        }
        int id = 0;
        for (auto f : adj) {
            assert(!f.empty());
            cout << f.size() << '\n';
            for (int x : f) {
                cout << x - head[id] + 1 << " ";
            }
            id += 1;
            cout << '\n';
        }
    }

    return 0;
}